Imports System.Data

Partial Class MenuAdmin_Permission
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '******************************************************************************
        ' Sub Name:     Page_Load
        ' Purpose:      
        ' Date Created: 6/1/2009
        ' Dev Name:     Lisa Mullan
        '*******************************************************************************
        Dim objCommon As New clsCommon
        Dim objSecurity As New clsSecurity
        Dim objPersonCore As New clsPersonCore
        Dim dtData As New DataTable
        Dim lst As New ListItem
        Dim row As DataRow

        Try
            ' fill person drop downi fill the dd 
            If Not IsPostBack Then
                ddPersonList.DataSource = objPersonCore.ReturnPersonList("True")
                ddPersonList.TextField = "FullName"
                ddPersonList.ValueField = "PersonID"
                ddPersonList.DataBind()
            End If

            'async panel
            If (objCommon.IsPostbackControl(Page, "ddPersonList")) Then

                If ddPersonList.SelectedValue > "" Then
                    UpdatePanel1.FindControl("lblTempMsg").Visible = False
                    dtData = objSecurity.ReturnPersonPermissionList(ddPersonList.SelectedValue)
                    chkPermissionList.DataSource = dtData
                    chkPermissionList.DataTextField = "PermissionName"
                    chkPermissionList.DataValueField = "PermissionID"
                    chkPermissionList.DataBind()

                    ' now check the items they have
                    For Each row In dtData.Rows
                        lst = chkPermissionList.Items.FindByValue(row("PermissionID"))
                        If row("HasPermission") = "1" Then
                            lst.Selected = True
                        Else
                            lst.Selected = False
                        End If
                    Next
                End If
            End If

        Catch Err As Exception
            Dim objErrorHandler As New clsCommon
            objErrorHandler.ErrorHandler("Permission.aspx", "Page_Load", Err.Message, Err.ToString(), "")
            objErrorHandler = Nothing
        Finally
            objCommon = Nothing
            objSecurity = Nothing
            objPersonCore = Nothing
        End Try
    End Sub



    Protected Sub btSave_ServerClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles btSave.ServerClick
        '******************************************************************************
        ' Sub Name:     btSave_ServerClick
        ' Purpose:      Save permissions to the database
        ' Date Created: 6/3/2009
        ' Dev Name:     Lisa Mullan
        '*******************************************************************************
        Dim objSecurity As New clsSecurity
        Dim objPersonCore As New clsPersonCore
        Dim dtData As New DataTable
        Dim row As DataRow
        Dim lst As New ListItem
        Dim objCommon As New clsCommon
        Dim dtSaveRecord As New DataTable


        Try
            If Page.IsValid Then
                If (objCommon.IsPostbackControl(Page, "btSave")) Then
                    dtSaveRecord.Columns.Add("PermissionID", GetType(Integer))
                    dtSaveRecord.Columns.Add("PersonID", GetType(Integer))

                    dtData = objSecurity.ReturnPersonPermissionList(ddPersonList.SelectedValue)

                    For Each row In dtData.Rows
                        lst = chkPermissionList.Items.FindByValue(row("PermissionID"))
                        If lst.Selected And row("HasPermission") = "0" Then
                            'they didn't have it, so add it
                            Dim newrow As DataRow
                            newrow = dtSaveRecord.NewRow()
                            newrow("PermissionID") = row("PermissionID")
                            newrow("PersonID") = ddPersonList.SelectedValue
                            dtSaveRecord.Rows.Add(newrow)
                            objCommon.AddRecord("PersonPermission", dtSaveRecord, objPersonCore.ReturnPersonID(Request.ServerVariables("AUTH_USER"), ""))
                        End If
                        If Not lst.Selected And row("HasPermission") = "1" Then
                            'they did have it and now they don't so delete it
                            objSecurity.DeletePermission(ddPersonList.SelectedValue, row("PermissionID"), objPersonCore.ReturnPersonID(Request.ServerVariables("AUTH_USER"), ""))
                        End If
                    Next
                    Response.Redirect("Default.aspx?m=Permissions updated successfully.&img=success", False)
                End If
            End If
        Catch Err As Exception
            Dim objErrorHandler As New clsCommon
            objErrorHandler.ErrorHandler("Permission.aspx", "btSave_ServerClick", Err.Message, Err.ToString(), "")
            objErrorHandler = Nothing
        Finally
            objSecurity = Nothing
            objCommon = Nothing
            objPersonCore = Nothing
        End Try
    End Sub
End Class
